#include "qwayland-greenisland-screencaster.h"

QT_BEGIN_NAMESPACE

namespace QtWayland {
    greenisland_screencaster::greenisland_screencaster(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    greenisland_screencaster::greenisland_screencaster(struct ::greenisland_screencaster *obj)
        : m_greenisland_screencaster(obj)
    {
    }

    greenisland_screencaster::greenisland_screencaster()
        : m_greenisland_screencaster(0)
    {
    }

    greenisland_screencaster::~greenisland_screencaster()
    {
    }

    void greenisland_screencaster::init(struct ::wl_registry *registry, int id, int version)
    {
        m_greenisland_screencaster = static_cast<struct ::greenisland_screencaster *>(wl_registry_bind(registry, id, &greenisland_screencaster_interface, version));
    }

    void greenisland_screencaster::init(struct ::greenisland_screencaster *obj)
    {
        m_greenisland_screencaster = obj;
    }

    bool greenisland_screencaster::isInitialized() const
    {
        return m_greenisland_screencaster != 0;
    }

    struct ::greenisland_screencast *greenisland_screencaster::capture(struct ::wl_output *output)
    {
        return greenisland_screencaster_capture(
            m_greenisland_screencaster,
            output);
    }

    greenisland_screencast::greenisland_screencast(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    greenisland_screencast::greenisland_screencast(struct ::greenisland_screencast *obj)
        : m_greenisland_screencast(obj)
    {
        init_listener();
    }

    greenisland_screencast::greenisland_screencast()
        : m_greenisland_screencast(0)
    {
    }

    greenisland_screencast::~greenisland_screencast()
    {
    }

    void greenisland_screencast::init(struct ::wl_registry *registry, int id, int version)
    {
        m_greenisland_screencast = static_cast<struct ::greenisland_screencast *>(wl_registry_bind(registry, id, &greenisland_screencast_interface, version));
        init_listener();
    }

    void greenisland_screencast::init(struct ::greenisland_screencast *obj)
    {
        m_greenisland_screencast = obj;
        init_listener();
    }

    bool greenisland_screencast::isInitialized() const
    {
        return m_greenisland_screencast != 0;
    }

    void greenisland_screencast::destroy()
    {
        greenisland_screencast_destroy(
            m_greenisland_screencast);
        m_greenisland_screencast = 0;
    }

    void greenisland_screencast::record(struct ::wl_buffer *buffer)
    {
        greenisland_screencast_record(
            m_greenisland_screencast,
            buffer);
    }

    void greenisland_screencast::screencast_setup(int32_t , int32_t , int32_t , int32_t )
    {
    }

    void greenisland_screencast::handle_setup(
        void *data,
        struct ::greenisland_screencast *object,
        int32_t width,
        int32_t height,
        int32_t stride,
        int32_t format)
    {
        Q_UNUSED(object);
        static_cast<greenisland_screencast *>(data)->screencast_setup(
            width,
            height,
            stride,
            format);
    }

    void greenisland_screencast::screencast_frame(struct ::wl_buffer *, uint32_t , int32_t )
    {
    }

    void greenisland_screencast::handle_frame(
        void *data,
        struct ::greenisland_screencast *object,
        struct ::wl_buffer *buffer,
        uint32_t time,
        int32_t transform)
    {
        Q_UNUSED(object);
        static_cast<greenisland_screencast *>(data)->screencast_frame(
            buffer,
            time,
            transform);
    }

    void greenisland_screencast::screencast_failed(int32_t , struct ::wl_buffer *)
    {
    }

    void greenisland_screencast::handle_failed(
        void *data,
        struct ::greenisland_screencast *object,
        int32_t error,
        struct ::wl_buffer *buffer)
    {
        Q_UNUSED(object);
        static_cast<greenisland_screencast *>(data)->screencast_failed(
            error,
            buffer);
    }

    void greenisland_screencast::screencast_cancelled(struct ::wl_buffer *)
    {
    }

    void greenisland_screencast::handle_cancelled(
        void *data,
        struct ::greenisland_screencast *object,
        struct ::wl_buffer *buffer)
    {
        Q_UNUSED(object);
        static_cast<greenisland_screencast *>(data)->screencast_cancelled(
            buffer);
    }

    const struct greenisland_screencast_listener greenisland_screencast::m_greenisland_screencast_listener = {
        greenisland_screencast::handle_setup,
        greenisland_screencast::handle_frame,
        greenisland_screencast::handle_failed,
        greenisland_screencast::handle_cancelled
    };

    void greenisland_screencast::init_listener()
    {
        greenisland_screencast_add_listener(m_greenisland_screencast, &m_greenisland_screencast_listener, this);
    }
}

QT_END_NAMESPACE
