#ifndef QT_WAYLAND_GREENISLAND_SCREENSHOOTER
#define QT_WAYLAND_GREENISLAND_SCREENSHOOTER

#include "wayland-greenisland-screenshooter-client-protocol.h"
#include <QByteArray>
#include <QString>

QT_BEGIN_NAMESPACE

namespace QtWayland {
    class  greenisland_screenshooter
    {
    public:
        greenisland_screenshooter(struct ::wl_registry *registry, int id, int version);
        greenisland_screenshooter(struct ::greenisland_screenshooter *object);
        greenisland_screenshooter();

        virtual ~greenisland_screenshooter();

        void init(struct ::wl_registry *registry, int id, int version);
        void init(struct ::greenisland_screenshooter *object);

        struct ::greenisland_screenshooter *object() { return m_greenisland_screenshooter; }
        const struct ::greenisland_screenshooter *object() const { return m_greenisland_screenshooter; }

        bool isInitialized() const;

        enum effects {
            effects_pointer = 1, // include the pointer
            effects_border = 2 // include the window border
        };

        struct ::greenisland_screenshot *capture_output(struct ::wl_output *output, const QByteArray &effects);
        struct ::greenisland_screenshot *capture_active(const QByteArray &effects);
        struct ::greenisland_screenshot *capture_surface(const QByteArray &effects);
        struct ::greenisland_screenshot *capture_area(const QByteArray &effects);

    private:
        struct ::greenisland_screenshooter *m_greenisland_screenshooter;
    };

    class  greenisland_screenshot
    {
    public:
        greenisland_screenshot(struct ::wl_registry *registry, int id, int version);
        greenisland_screenshot(struct ::greenisland_screenshot *object);
        greenisland_screenshot();

        virtual ~greenisland_screenshot();

        void init(struct ::wl_registry *registry, int id, int version);
        void init(struct ::greenisland_screenshot *object);

        struct ::greenisland_screenshot *object() { return m_greenisland_screenshot; }
        const struct ::greenisland_screenshot *object() const { return m_greenisland_screenshot; }

        bool isInitialized() const;

        enum error {
            error_bad_buffer = 0 // Buffer doesn't match requirements
        };

        void destroy();
        void record(struct ::wl_buffer *buffer);

    protected:
        virtual void screenshot_setup(int32_t width, int32_t height, int32_t stride, int32_t format);
        virtual void screenshot_done();
        virtual void screenshot_failed(int32_t error);

    private:
        void init_listener();
        static const struct greenisland_screenshot_listener m_greenisland_screenshot_listener;
        static void handle_setup(
            void *data,
            struct ::greenisland_screenshot *object,
            int32_t width,
            int32_t height,
            int32_t stride,
            int32_t format);
        static void handle_done(
            void *data,
            struct ::greenisland_screenshot *object);
        static void handle_failed(
            void *data,
            struct ::greenisland_screenshot *object,
            int32_t error);
        struct ::greenisland_screenshot *m_greenisland_screenshot;
    };
}

QT_END_NAMESPACE

#endif
