#include "qwayland-server-greenisland-screenshooter.h"

QT_BEGIN_NAMESPACE

namespace QtWaylandServer {
    greenisland_screenshooter::greenisland_screenshooter(struct ::wl_client *client, int id, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(client, id, version);
    }

    greenisland_screenshooter::greenisland_screenshooter(struct ::wl_display *display, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(display, version);
    }

    greenisland_screenshooter::greenisland_screenshooter(struct ::wl_resource *resource)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(resource);
    }

    greenisland_screenshooter::greenisland_screenshooter()
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
    }

    greenisland_screenshooter::~greenisland_screenshooter()
    {
    }

    void greenisland_screenshooter::init(struct ::wl_client *client, int id, int version)
    {
        m_resource = bind(client, id, version);
    }

    void greenisland_screenshooter::init(struct ::wl_resource *resource)
    {
        m_resource = bind(resource);
    }

    greenisland_screenshooter::Resource *greenisland_screenshooter::add(struct ::wl_client *client, int version)
    {
        Resource *resource = bind(client, 0, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    greenisland_screenshooter::Resource *greenisland_screenshooter::add(struct ::wl_client *client, int id, int version)
    {
        Resource *resource = bind(client, id, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    void greenisland_screenshooter::init(struct ::wl_display *display, int version)
    {
        m_global = wl_global_create(display, &::greenisland_screenshooter_interface, version, this, bind_func);
        m_globalVersion = version;
    }

    const struct wl_interface *greenisland_screenshooter::interface()
    {
        return &::greenisland_screenshooter_interface;
    }

    greenisland_screenshooter::Resource *greenisland_screenshooter::screenshooter_allocate()
    {
        return new Resource;
    }

    void greenisland_screenshooter::screenshooter_bind_resource(Resource *)
    {
    }

    void greenisland_screenshooter::screenshooter_destroy_resource(Resource *)
    {
    }

    void greenisland_screenshooter::bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id)
    {
        greenisland_screenshooter *that = static_cast<greenisland_screenshooter *>(data);
        that->add(client, id, qMin(that->m_globalVersion, version));
    }

    void greenisland_screenshooter::destroy_func(struct ::wl_resource *client_resource)
    {
        Resource *resource = Resource::fromResource(client_resource);
        greenisland_screenshooter *that = resource->screenshooter_object;
        that->m_resource_map.remove(resource->client(), resource);
        that->screenshooter_destroy_resource(resource);
        delete resource;
#if !WAYLAND_VERSION_CHECK(1, 2, 0)
        free(client_resource);
#endif
    }

    greenisland_screenshooter::Resource *greenisland_screenshooter::bind(struct ::wl_client *client, uint32_t id, int version)
    {
        Q_ASSERT_X(!wl_client_get_object(client, id), "QWaylandObject bind", QStringLiteral("binding to object %1 more than once").arg(id).toLocal8Bit().constData());
        struct ::wl_resource *handle = wl_resource_create(client, &::greenisland_screenshooter_interface, version, id);
        return bind(handle);
    }

    greenisland_screenshooter::Resource *greenisland_screenshooter::bind(struct ::wl_resource *handle)
    {
        Resource *resource = screenshooter_allocate();
        resource->screenshooter_object = this;

        wl_resource_set_implementation(handle, &m_greenisland_screenshooter_interface, resource, destroy_func);
        resource->handle = handle;
        m_resource = resource;
        screenshooter_bind_resource(resource);
        return resource;
    }

    const struct ::greenisland_screenshooter_interface greenisland_screenshooter::m_greenisland_screenshooter_interface = {
        greenisland_screenshooter::handle_capture_output,
        greenisland_screenshooter::handle_capture_active,
        greenisland_screenshooter::handle_capture_surface,
        greenisland_screenshooter::handle_capture_area
    };

    void greenisland_screenshooter::screenshooter_capture_output(Resource *, uint32_t, struct ::wl_resource *, wl_array *)
    {
    }

    void greenisland_screenshooter::screenshooter_capture_active(Resource *, uint32_t, wl_array *)
    {
    }

    void greenisland_screenshooter::screenshooter_capture_surface(Resource *, uint32_t, wl_array *)
    {
    }

    void greenisland_screenshooter::screenshooter_capture_area(Resource *, uint32_t, wl_array *)
    {
    }


    void greenisland_screenshooter::handle_capture_output(
        ::wl_client *client,
        struct wl_resource *resource,
        uint32_t id,
        struct ::wl_resource *output,
        wl_array *effects)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_screenshooter *>(r->screenshooter_object)->screenshooter_capture_output(
            r,
            id,
            output,
            effects);
    }

    void greenisland_screenshooter::handle_capture_active(
        ::wl_client *client,
        struct wl_resource *resource,
        uint32_t id,
        wl_array *effects)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_screenshooter *>(r->screenshooter_object)->screenshooter_capture_active(
            r,
            id,
            effects);
    }

    void greenisland_screenshooter::handle_capture_surface(
        ::wl_client *client,
        struct wl_resource *resource,
        uint32_t id,
        wl_array *effects)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_screenshooter *>(r->screenshooter_object)->screenshooter_capture_surface(
            r,
            id,
            effects);
    }

    void greenisland_screenshooter::handle_capture_area(
        ::wl_client *client,
        struct wl_resource *resource,
        uint32_t id,
        wl_array *effects)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_screenshooter *>(r->screenshooter_object)->screenshooter_capture_area(
            r,
            id,
            effects);
    }

    greenisland_screenshot::greenisland_screenshot(struct ::wl_client *client, int id, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(client, id, version);
    }

    greenisland_screenshot::greenisland_screenshot(struct ::wl_display *display, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(display, version);
    }

    greenisland_screenshot::greenisland_screenshot(struct ::wl_resource *resource)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(resource);
    }

    greenisland_screenshot::greenisland_screenshot()
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
    }

    greenisland_screenshot::~greenisland_screenshot()
    {
    }

    void greenisland_screenshot::init(struct ::wl_client *client, int id, int version)
    {
        m_resource = bind(client, id, version);
    }

    void greenisland_screenshot::init(struct ::wl_resource *resource)
    {
        m_resource = bind(resource);
    }

    greenisland_screenshot::Resource *greenisland_screenshot::add(struct ::wl_client *client, int version)
    {
        Resource *resource = bind(client, 0, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    greenisland_screenshot::Resource *greenisland_screenshot::add(struct ::wl_client *client, int id, int version)
    {
        Resource *resource = bind(client, id, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    void greenisland_screenshot::init(struct ::wl_display *display, int version)
    {
        m_global = wl_global_create(display, &::greenisland_screenshot_interface, version, this, bind_func);
        m_globalVersion = version;
    }

    const struct wl_interface *greenisland_screenshot::interface()
    {
        return &::greenisland_screenshot_interface;
    }

    greenisland_screenshot::Resource *greenisland_screenshot::screenshot_allocate()
    {
        return new Resource;
    }

    void greenisland_screenshot::screenshot_bind_resource(Resource *)
    {
    }

    void greenisland_screenshot::screenshot_destroy_resource(Resource *)
    {
    }

    void greenisland_screenshot::bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id)
    {
        greenisland_screenshot *that = static_cast<greenisland_screenshot *>(data);
        that->add(client, id, qMin(that->m_globalVersion, version));
    }

    void greenisland_screenshot::destroy_func(struct ::wl_resource *client_resource)
    {
        Resource *resource = Resource::fromResource(client_resource);
        greenisland_screenshot *that = resource->screenshot_object;
        that->m_resource_map.remove(resource->client(), resource);
        that->screenshot_destroy_resource(resource);
        delete resource;
#if !WAYLAND_VERSION_CHECK(1, 2, 0)
        free(client_resource);
#endif
    }

    greenisland_screenshot::Resource *greenisland_screenshot::bind(struct ::wl_client *client, uint32_t id, int version)
    {
        Q_ASSERT_X(!wl_client_get_object(client, id), "QWaylandObject bind", QStringLiteral("binding to object %1 more than once").arg(id).toLocal8Bit().constData());
        struct ::wl_resource *handle = wl_resource_create(client, &::greenisland_screenshot_interface, version, id);
        return bind(handle);
    }

    greenisland_screenshot::Resource *greenisland_screenshot::bind(struct ::wl_resource *handle)
    {
        Resource *resource = screenshot_allocate();
        resource->screenshot_object = this;

        wl_resource_set_implementation(handle, &m_greenisland_screenshot_interface, resource, destroy_func);
        resource->handle = handle;
        m_resource = resource;
        screenshot_bind_resource(resource);
        return resource;
    }

    const struct ::greenisland_screenshot_interface greenisland_screenshot::m_greenisland_screenshot_interface = {
        greenisland_screenshot::handle_destroy,
        greenisland_screenshot::handle_record
    };

    void greenisland_screenshot::screenshot_destroy(Resource *)
    {
    }

    void greenisland_screenshot::screenshot_record(Resource *, struct ::wl_resource *)
    {
    }


    void greenisland_screenshot::handle_destroy(
        ::wl_client *client,
        struct wl_resource *resource)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_screenshot *>(r->screenshot_object)->screenshot_destroy(
            r);
    }

    void greenisland_screenshot::handle_record(
        ::wl_client *client,
        struct wl_resource *resource,
        struct ::wl_resource *buffer)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_screenshot *>(r->screenshot_object)->screenshot_record(
            r,
            buffer);
    }

    void greenisland_screenshot::send_setup(int32_t width, int32_t height, int32_t stride, int32_t format)
    {
        send_setup(
            m_resource->handle,
            width,
            height,
            stride,
            format);
    }

    void greenisland_screenshot::send_setup(struct ::wl_resource *resource, int32_t width, int32_t height, int32_t stride, int32_t format)
    {
        greenisland_screenshot_send_setup(
            resource,
            width,
            height,
            stride,
            format);
    }


    void greenisland_screenshot::send_done()
    {
        send_done(
            m_resource->handle);
    }

    void greenisland_screenshot::send_done(struct ::wl_resource *resource)
    {
        greenisland_screenshot_send_done(
            resource);
    }


    void greenisland_screenshot::send_failed(int32_t error)
    {
        send_failed(
            m_resource->handle,
            error);
    }

    void greenisland_screenshot::send_failed(struct ::wl_resource *resource, int32_t error)
    {
        greenisland_screenshot_send_failed(
            resource,
            error);
    }

}

QT_END_NAMESPACE
