/* 
 * Copyright (C) 2015-2016 Pier Luigi Fiorini
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <stdint.h>
#include "wayland-util.h"

extern const struct wl_interface greenisland_window_interface;

static const struct wl_interface *types[] = {
	NULL,
	NULL,
	&greenisland_window_interface,
	NULL,
	NULL,
	NULL,
	NULL,
};

static const struct wl_message greenisland_applications_requests[] = {
	{ "quit", "s", types + 0 },
};

static const struct wl_message greenisland_applications_events[] = {
	{ "registered", "su", types + 0 },
	{ "unregistered", "su", types + 0 },
	{ "focused", "s", types + 0 },
	{ "unfocused", "s", types + 0 },
};

WL_EXPORT const struct wl_interface greenisland_applications_interface = {
	"greenisland_applications", 1,
	1, greenisland_applications_requests,
	4, greenisland_applications_events,
};

static const struct wl_message greenisland_windows_events[] = {
	{ "window_mapped", "nuuss", types + 2 },
};

WL_EXPORT const struct wl_interface greenisland_windows_interface = {
	"greenisland_windows", 1,
	0, NULL,
	1, greenisland_windows_events,
};

static const struct wl_message greenisland_window_events[] = {
	{ "title_changed", "s", types + 0 },
	{ "app_id_changed", "s", types + 0 },
	{ "state_changed", "u", types + 0 },
	{ "workspace_changed", "u", types + 0 },
	{ "unmapped", "", types + 0 },
};

WL_EXPORT const struct wl_interface greenisland_window_interface = {
	"greenisland_window", 1,
	0, NULL,
	5, greenisland_window_events,
};

